import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from '@msfa-environment';
import { AvvikelseReportResponse } from '@msfa-models/api/avvikelse-response.model';
import { FranvaroReportResponse } from '@msfa-models/api/franvaro-response.model';
import { GemensamPlaneringResponse } from '@msfa-models/api/gemensam-planering.response.model';
import { InformativRapportResponse } from '@msfa-models/api/informativ-rapport.response.model';
import { PeriodiskRedovisningResponse } from '@msfa-models/api/periodisk-redovisning.response.model';
import { SignalResponse } from '@msfa-models/api/signal.response.model';
import { SlutredovisningResponse } from '@msfa-models/api/slutredovisning.response.model';
import { CustomError } from '@msfa-models/error/custom-error';
import { Observable } from 'rxjs';
import { catchError } from 'rxjs/operators';

@Injectable({
  providedIn: 'root',
})
export class HandlingarApiService {
  private _apiBaseUrl = `${environment.api.url}/handlingar`;

  constructor(private httpClient: HttpClient) {}

  public fetchGemensamPlanering$(handlingId: string): Observable<{ data: GemensamPlaneringResponse }> {
    return this.httpClient
      .get<{ data: GemensamPlaneringResponse }>(`${this._apiBaseUrl}/gemensam-planering/${handlingId}`)
      .pipe(
        catchError((error: Error) => {
          throw new CustomError({
            error,
            message: `Kunde inte hämta Gemensam planering.\n\n${error.message}`,
            name: `GET ${this._apiBaseUrl}/gemensam-planering/{handlingId}`,
            data: { handlingId },
            method: 'HandlingarApiService.fetchGemensamPlanering$',
          });
        })
      );
  }

  public fetchPeriodiskRedovisning$(handlingId: string): Observable<{ data: PeriodiskRedovisningResponse }> {
    return this.httpClient
      .get<{ data: PeriodiskRedovisningResponse }>(`${this._apiBaseUrl}/periodisk-redovisning/${handlingId}`)
      .pipe(
        catchError((error: Error) => {
          throw new CustomError({
            error,
            message: `Kunde inte hämta Periodisk redovisning.\n\n${error.message}`,
            name: `GET ${this._apiBaseUrl}/periodisk-redovisning/{handlingId}`,
            data: { handlingId },
            method: 'HandlingarApiService.fetchPeriodiskRedovisning$',
          });
        })
      );
  }

  public fetchInformativRapport$(handlingId: string): Observable<{ data: InformativRapportResponse }> {
    return this.httpClient
      .get<{ data: InformativRapportResponse }>(`${this._apiBaseUrl}/informativ-rapport/${handlingId}`)
      .pipe(
        catchError((error: Error) => {
          throw new CustomError({
            error,
            message: `Kunde inte hämta Informativ rapport.\n\n${error.message}`,
            name: `GET ${this._apiBaseUrl}/informativ-rapport/{handlingId}`,
            data: { handlingId },
            method: 'HandlingarApiService.fetchInformativRapport$',
          });
        })
      );
  }
  public fetchSignal$(handlingId: string): Observable<{ data: SignalResponse }> {
    return this.httpClient.get<{ data: SignalResponse }>(`${this._apiBaseUrl}/signal/${handlingId}`).pipe(
      catchError((error: Error) => {
        throw new CustomError({
          error,
          message: `Kunde inte hämta Signal om arbete eller studier.\n\n${error.message}`,
          name: `GET ${this._apiBaseUrl}/signal/{handlingId}`,
          data: { handlingId },
          method: 'HandlingarApiService.fetchSignal$',
        });
      })
    );
  }

  public fetchFranvaroReport$(handlingId: string): Observable<{ data: FranvaroReportResponse }> {
    return this.httpClient.get<{ data: FranvaroReportResponse }>(`${this._apiBaseUrl}/franvaro/${handlingId}`).pipe(
      catchError((error: Error) => {
        throw new CustomError({
          error,
          message: `Kunde inte hämta Avvikelserapport (frånvaro).\n\n${error.message}`,
          name: `GET ${this._apiBaseUrl}/franvaro/{handlingId}`,
          data: { handlingId },
          method: 'HandlingarApiService.fetchFranvaroReport$',
        });
      })
    );
  }

  public fetchAvvikelseReport$(handlingId: string): Observable<{ data: AvvikelseReportResponse }> {
    return this.httpClient.get<{ data: AvvikelseReportResponse }>(`${this._apiBaseUrl}/avvikelse/${handlingId}`).pipe(
      catchError((error: Error) => {
        throw new CustomError({
          error,
          message: `Kunde inte hämta Avvikelserapport (avvikelse).\n\n${error.message}`,
          name: `GET ${this._apiBaseUrl}/avvikelse/{handlingId}`,
          data: { handlingId },
          method: 'HandlingarApiService.fetchAvvikelseReport$',
        });
      })
    );
  }

  public fetchSlutredovisning$(handlingId: string): Observable<{ data: SlutredovisningResponse }> {
    return this.httpClient
      .get<{ data: SlutredovisningResponse }>(`${this._apiBaseUrl}/slutredovisning/${handlingId}`)
      .pipe(
        catchError((error: Error) => {
          throw new CustomError({
            error,
            message: `Kunde inte hämta Slutredovisning.\n\n${error.message}`,
            name: `GET ${this._apiBaseUrl}/slutredovisning/{handlingId}`,
            data: { handlingId },
            method: 'HandlingarApiService.fetchSlutredovisning$',
          });
        })
      );
  }
}
